package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * MdnsRuleOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class MdnsRuleOpenApiVo   {
  @JsonProperty("id")
  private String id;

  @JsonProperty("name")
  private String name;

  @JsonProperty("status")
  private Boolean status;

  @JsonProperty("profileIds")
  @Valid
  private List<String> profileIds = null;

  @JsonProperty("type")
  private Integer type;

  @JsonProperty("ap")
  private ApMdnsRuleOpenApiVo ap;

  @JsonProperty("osg")
  private OsgMdnsRuleOpenApiVo osg;

  public MdnsRuleOpenApiVo id(String id) {
    this.id = id;
    return this;
  }

  /**
   * MDNS rule ID
   * @return id
  */
  @ApiModelProperty(value = "MDNS rule ID")


  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public MdnsRuleOpenApiVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * MDNS rule name
   * @return name
  */
  @ApiModelProperty(value = "MDNS rule name")


  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public MdnsRuleOpenApiVo status(Boolean status) {
    this.status = status;
    return this;
  }

  /**
   * MDNS rule enable status
   * @return status
  */
  @ApiModelProperty(value = "MDNS rule enable status")


  public Boolean getStatus() {
    return status;
  }

  public void setStatus(Boolean status) {
    this.status = status;
  }

  public MdnsRuleOpenApiVo profileIds(List<String> profileIds) {
    this.profileIds = profileIds;
    return this;
  }

  public MdnsRuleOpenApiVo addProfileIdsItem(String profileIdsItem) {
    if (this.profileIds == null) {
      this.profileIds = new ArrayList<>();
    }
    this.profileIds.add(profileIdsItem);
    return this;
  }

  /**
   * ID list of selected Bonjour Service Profile
   * @return profileIds
  */
  @ApiModelProperty(value = "ID list of selected Bonjour Service Profile")


  public List<String> getProfileIds() {
    return profileIds;
  }

  public void setProfileIds(List<String> profileIds) {
    this.profileIds = profileIds;
  }

  public MdnsRuleOpenApiVo type(Integer type) {
    this.type = type;
    return this;
  }

  /**
   * MDNS rule type, 0: AP, 1: Gateway
   * @return type
  */
  @ApiModelProperty(value = "MDNS rule type, 0: AP, 1: Gateway")


  public Integer getType() {
    return type;
  }

  public void setType(Integer type) {
    this.type = type;
  }

  public MdnsRuleOpenApiVo ap(ApMdnsRuleOpenApiVo ap) {
    this.ap = ap;
    return this;
  }

  /**
   * Get ap
   * @return ap
  */
  @ApiModelProperty(value = "")

  @Valid

  public ApMdnsRuleOpenApiVo getAp() {
    return ap;
  }

  public void setAp(ApMdnsRuleOpenApiVo ap) {
    this.ap = ap;
  }

  public MdnsRuleOpenApiVo osg(OsgMdnsRuleOpenApiVo osg) {
    this.osg = osg;
    return this;
  }

  /**
   * Get osg
   * @return osg
  */
  @ApiModelProperty(value = "")

  @Valid

  public OsgMdnsRuleOpenApiVo getOsg() {
    return osg;
  }

  public void setOsg(OsgMdnsRuleOpenApiVo osg) {
    this.osg = osg;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MdnsRuleOpenApiVo mdnsRuleOpenApiVo = (MdnsRuleOpenApiVo) o;
    return Objects.equals(this.id, mdnsRuleOpenApiVo.id) &&
        Objects.equals(this.name, mdnsRuleOpenApiVo.name) &&
        Objects.equals(this.status, mdnsRuleOpenApiVo.status) &&
        Objects.equals(this.profileIds, mdnsRuleOpenApiVo.profileIds) &&
        Objects.equals(this.type, mdnsRuleOpenApiVo.type) &&
        Objects.equals(this.ap, mdnsRuleOpenApiVo.ap) &&
        Objects.equals(this.osg, mdnsRuleOpenApiVo.osg);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, status, profileIds, type, ap, osg);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MdnsRuleOpenApiVo {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    profileIds: ").append(toIndentedString(profileIds)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    ap: ").append(toIndentedString(ap)).append("\n");
    sb.append("    osg: ").append(toIndentedString(osg)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

